#ifndef L5_APPLICATION_MY_MIDI_HPP_
#define L5_APPLICATION_MY_MIDI_HPP_

#include "LPC17xx.h"
#include "scheduler_task.hpp"
#include "stdio.h"

#define QUEUE_SIZE      5
#define SET_PARAMETERS  0xB0
#define NOTE_ON         0x90
#define NOTE_OFF        0x80
#define SET_VOLUME      0x07
#define INIT_VOLUME     0x50
#define SET_INSTR       0xC0
#define INIT_INSTR      0x01
#define MAX_VOLUME      0x7F
#define MAX_INSTR       0x7F
#define MAX_VELOCITY    0x7F
#define BYTE_PADDING    0x00
#define INC             1
#define DEC             -1




enum note_t{
    quiet,
    note0,
    note1,
    note2,
    note3,
    note4,
    note5,
    note6,
    note7
};
enum shared_queue_id{
    MIDI_QUEUE
};
// SPI Functions
void ssp_init(void);
void ssp_cs(void);
void ssp_ds(void);
char ssp_trx(char in);
// MIDI Functions
void midi_init(void);
void midi_xdcs(void);
void midi_xdds(void);
void midi_send_msg(char, char, char);
char change_volume(char);
char change_instr(char);
/***********************MIDI TASK**********************/
class MIDITask : public scheduler_task
{
    private:
    public:
        MIDITask(uint8_t priority) : scheduler_task("MIDI", 512*4, priority) { }
        bool init(void);
        bool run(void *p);
};



#endif /* L5_APPLICATION_MY_MIDI_HPP_ */
